<template>
  <section class="flex justify-center mt-4">
    <div class="w-[1200px]">
      <div :class="['flex', { 'gap-2': isCompactEnabled }]">
        <template v-for="(banner, index) in banners" :key="index">
          <div v-if="index < 4">
            <figure :class="`img-container ${variant}`">
              <img :src="banner.ImagePath" loading="lazy" />
            </figure>
            <div v-if="isCompactEnabled" class="content">
              <div class="header">
                <div>
                  <dot-decoration />
                  <span class="--text4">{{ $t(banner.Text) }}</span>
                </div>
                <a class="cta" :href="banner.HyperLink" :title="$t('try_now')">
                  <span class="truncate">{{ $t("try_now") }}</span>
                </a>
              </div>
              <hr />
              <div
                class="footer --text4"
                v-if="handleContent(index) && !handleContent(index).IsHidden"
              >
                {{ handleContent(index).Text }}
              </div>
            </div>
          </div>
        </template>
      </div>
    </div>
  </section>
</template>

<script lang="ts" setup>
import { store } from "@/store";
import EnumBannerVersion from "@/models/enums/enumBannerVersion";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";

const props = defineProps({
  variant: {
    type: String,
    default: EnumBannerVersion.Tall,
  },
});
const isCompactEnabled: boolean = props.variant === "compact";
const themeProperties =
  store.state.companyThemePropertiesFromApi.ThemeProperties;
const banners = themePropertyHelper.getMultipleThemesProperties(
  themeProperties,
  "index_blog_1_"
);
const handleContent = (index: number): IThemePropertiesFromApi =>
  themePropertyHelper.getSingleThemeProperty(
    themeProperties,
    `index_blog_content_1_${index + 1}`
  );
</script>

<style lang="scss" scoped>
.img-container {
  overflow: hidden;
  &.compact {
    width: 294px;
    height: 200px;
    border-radius: 8px;
  }
  &.tall {
    width: 300px;
    height: 480px;
  }
  img {
    transition: scale 0.5s ease-in-out;
    &:hover {
      scale: 1.2;
    }
  }
}
.content {
  display: flex;
  flex-direction: column;
  min-height: 100px;
  gap: 8px;
  background: var(--background5);
  align-items: flex-start;
  margin-top: 8px;
  padding: 8px;
  border-radius: 8px;

  & > * {
    align-self: stretch;
  }

  & .header {
    position: relative;
    display: flex;
    justify-content: space-between;

    & > div {
      display: flex;
      gap: 8px;
      align-items: center;
      height: 22px;

      & > * {
        height: 100%;
      }
    }
  }

  .cta {
    color: var(--textBtn);
    background: var(--primary);
    padding: 4px 10px;
    border-radius: 4px;
    display: flex;
    align-items: center;
    min-width: 72px;
    height: 24px;
  }
}
hr {
  height: 1px;
  border: none;
  background: linear-gradient(
    90deg,
    rgba(255, 255, 255, 0) 0%,
    #ffffff 50%,
    rgba(255, 255, 255, 0) 100%
  );
}
</style>
